Subject: bug#17978: 24.3; forward-paragraph broken with javadocs

From: Justine Tunney <[email-masked]>
Date: Wed, 9 Jul 2014 19:40:50 -0400

Assume that I have the following Java source, where # indicates the cursor
position:

/**
 * Does stuff.
 *
 * <p>Hello
 *
 * @see FooBar
 */
private void lol() {}
#

So I press C-{ and this is what happens:

/**
 * Does stuff.
 *
 * <p>Hello
 *
#* @see FooBar
 */
private void lol() {}

And then I press it again:

/**
 * Does stuff.
 *
#* <p>Hello
 *
 * @see FooBar
 */
private void lol() {}

And here's what I expected to happen:

#
/**
 * Does stuff.
 *
 * <p>Hello
 *
 * @see FooBar
 */
private void lol() {}

C-{ and C-} should cycle between blank lines. But the reason why this
doesn't happen in java-mode, is because Java redefines the definition of a
paragraph. It sets the paragraph-start variable (among other variables) so
that when I M-q to fill-paragraph, it'll work correctly *within* the
Javadoc, rather than reflowing my code into a jumbled mess.

On Wed, Jul 9, 2014 at 6:28 PM, Stefan Monnier <[email-masked]>
wrote:

> > I included a video explanation: http://youtu.be/cXerimuxNK8
>
> Could you just send plain text showing an example piece of code, then
> a command you use on it, the end result you get and the end result you'd
> like to get instead?
>
> That's surely easier to do, and will save me the trouble of dealing with
> videos which I find unbearable (you can't just look at them, you have to
> additionally listen to them; if you get distracted along the way you end
> up having to start over; half the time there's a technical problem; you
> can't choose the speed at which you "read/view", so you have to wait
> for irrelevant crap before getting to the point; it's a huge waste of
> bandwidth).
>
>
>         Stefan
>